from charmhelpers.core import hookenv
from charmhelpers.contrib.openstack.context import OSContextGenerator


class RenderContext(OSContextGenerator):
    def __call__(self):
        if not hookenv.relation_ids(self.interface):
            return {}

        ctx = {}
        for rid in hookenv.relation_ids(self.interface):
            for unit in hookenv.related_units(rid):
                reldata = hookenv.relation_get(rid=rid, unit=unit)
                required = set(self.required_keys)
                if set(reldata.keys()) == required:
                    for k, v in reldata.items():
                        ctx["%s.%s" % (self.interface, k)] = v
                    return ctx

        return {}


class NatsContext(RenderContext):
    interface = 'nats'
    required_keys = ['nats_port', 'nats_host']


class RouterContext(RenderContext):
    interface = 'router'
    required_keys = ['router_domain']
